//      usolibso.c
//      
//      Copyright 2012 grchere <grchere@debian2>
//      
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

/* ejemplo de ejecucion
 *desencripto 
./usolibso /home/grchere/proyectos/libencr1/libencr2.so linklib.enc2 linklib.sh3 d

 *encripto
./usolibso /home/grchere/proyectos/libencr1/libencr2.so linklib.sh linklib.enc2 e
 
*/ 

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h> // requerido para cargar,buscar simbolos y descargar libreria dinamica

int main(int argc, char **argv)
{
	if ( argc != 5 ) {
		printf("Error!, debe indicar:\nusolibso <lib.so> <input file> <output file> <op>\n<op> {e,d}\n");
		exit(1);
	}
	if ( !(*argv[4] == 'e' || *argv[4] == 'd') ) {
		printf("Error!, <op> debe ser una 'e' o una 'd'\n");
		exit(2);
	}
	printf("uso libreria [%s]\n",argv[1]);	

	FILE *fpi = fopen(argv[2],"rb");
	FILE *fpo = fopen(argv[3],"wb");
	fseek(fpi,0L,SEEK_END);
	int largo = (int) ftell(fpi);
	printf("El archivo [%s] tiene un largo de %d bytes\n",argv[2],largo);
	// asignar memoria para cargar el archivo en memoria
	char *buffer = (char *) malloc(largo);
	fseek(fpi,0L,SEEK_SET);
	fread(buffer,largo,1,fpi);
	fclose(fpi);
	
   void *libfp; // puntero a libreria
   void (*encripto)(char *,int); // puntero a funcion 
   void (*desencripto)(char *,int); // puntero a funcion 

   char *error;
   // cargo libreria
   libfp = dlopen (argv[1], RTLD_NOW);
   if (!libfp) {
      fprintf(stderr,"Error cargando libreria pruebadl.so\n");
      fprintf(stderr,dlerror());
      return 1;
   }
   // ubico funciones
   encripto = dlsym(libfp, "encripto");
   if ((error = dlerror()) != NULL) {
      fprintf(stderr,"Error buscando encripto\n");
      fprintf(stderr,dlerror());
      return 1;
   }
   desencripto = dlsym(libfp, "desencripto");
   if ((error = dlerror()) != NULL) {
      fprintf(stderr,"Error buscando desencripto\n");
      fprintf(stderr,dlerror());
      return 1;
   }

   // ejecuto funcion
	if ( *argv[4] == 'e' ) {
		printf("voy a ejecutar encripto\n");
		(*encripto)(buffer,largo);
	} else {
		printf("voy a ejecutar desencripto\n");
		(*desencripto)(buffer,largo);
	}
	fwrite(buffer,largo,1,fpo);
	fclose(fpo);

   // libero libreria
   dlclose(libfp);
	
	return 0;
}

